<?PHP

/**
 * AutoBlogged admin page
 *
 * PHP version 5
 *
 * @package   AutoBlogged v2
 * @author    AutoBlogged <support@autoblogged.com>
 * @copyright Copyright (c)2011 AutoBlogged, ALL RIGHTS RESERVED
 * @version   SVN Build: $Id: ab-admin.php 49 2011-04-05 03:56:39Z dev $
 */

/**
* Admin page header
*
* @return void
*/
function ab_adminPageHeader() {
	global $wpdb, $feedtypes, $ab_options, $autoblogged;
	if (function_exists('wp_get_current_user')) {
		if (!current_user_can('manage_options')) {
			ab_wperror('Warning: Access denied.');
		}
	}

	
	// Quick security check
	if (strlen($_REQUEST['_fid']) && !is_numeric($_REQUEST['_fid'])) {
		ab_wperror('Error: Access Denied');
	}

	// First do DB version check
	$installed_ver = get_option("autoblogged_db_version");
	if ($installed_ver != DB_SCHEMA_AB_VERSION) {
		ab_installOnActivation();
	}

	// Check to see if we are disabling or enabling a feed
	if ($_GET['action'] == 'enable' && isset($_REQUEST['_fid'])) {
		$sql = 'UPDATE '.ab_tableName().' SET `enabled`=1 WHERE id='.$wpdb->escape($_GET['_fid']).';';
		$ret = $wpdb->query($sql);
	}
	if ($_GET['action'] == 'disable' && isset($_REQUEST['_fid'])) {
		$sql = 'UPDATE '.ab_tableName().' SET `enabled`=0 WHERE id='.$wpdb->escape($_GET['_fid']).';';
		$ret = $wpdb->query($sql);
	}
	if ($_GET['action'] == 'run') check_admin_referer('autoblogged-nav');

	// Very simple obfuscation
	if (true) {
		$x0c = "\x73\x74r\154e\156";
		$x0d = "\x75\x72\x6c\145\156c\x6f\144\x65";
		$xxc = 'blog'.'ged';
		if (isset($_POST['sn']) && $x0c($x0b['sn']) == 0) {
			ab_httpFetch('ht'.'tp://auto'.$xxc.'.com/re'.'gis'.'ter.php?re'.'g'.''.'n'.'um='.$x0d($_POST['sn']));
		}
	}

	// Save any options submitted via a form post
	if (array_key_exists('_submit_check', $_POST) || ($_GET['action'] == 'add')) {
		
		do_action('autoblogged_save_options', $_POST);
		
		// Handle feed edits
		if (isset($_POST['_fid']) || $_GET['action'] == 'add') {

			// Special handling for checkboxes
			$_POST['addothercats'] = intval(isset($_POST['addothercats']));
			$_POST['addcatsastags'] = intval(isset($_POST['addcatsastags']));
			$_POST['createthumbs'] = intval(isset($_POST['createthumbs']));
			$_POST['usepostcats'] = intval(isset($_POST['usepostcats']));
			$_POST['addpostcats'] = intval(isset($_POST['addpostcats']));
			$_POST['usefeeddate'] = intval(isset($_POST['usefeeddate']));

			// Special handling for feed type to get the ID
			if (isset($_POST['type'])) {
				$_POST['type'] = array_search($_POST['type'], $feedtypes);
			}

			// Special handling for tags
			if (isset($_POST['tags_input'])) {
				$_POST['tags'] = explode(',', $_POST['tags_input']);
			}

			// Special handling for categories
			if (isset($_POST['post_category'])) {
				$_POST['category'] = $_POST['post_category'];
			}

			// Extra post stuff we won't be saving in the DB
			$searchtypes = array();
			$searchtypes = $_POST['searchtype'];
			unset($_POST['post_category'], $_POST['tags_input'], $_POST['newtag'], $_POST['newcat'], $_POST['newcat_parent'], $_POST['searchtype']);

			// Insert new record or update existing record
			if (empty($_POST['_fid'])) {
				unset($_POST['_fid']);
				$sql = "INSERT INTO ".ab_tableName();
			} else {
				$sql = "UPDATE ".ab_tableName();
			}
			$i = 0;
			$sql.= " SET ";
			foreach(array_keys($_POST) as $postitem) {

				// Skip anything that starts with underscore
				if (substr($postitem, 0, 1) <> '_') {
					$i++;
					if ($i > 1) {
						$sql.= ',';
					}
					if (is_array($_POST[$postitem])) {

						// Search and replace v2.8 hack
						if ($postitem == 'searchfor') {
							$j = 0;
							foreach($_POST[$postitem] as $postitemitem) {
								if (!empty($postitemitem)) {
									if ($searchtypes[$j] == 'Regular Expression') $_POST[$postitem][$j] = '!!0!!'.$_POST[$postitem][$j];
									if ($searchtypes[$j] == 'Plain Text') $_POST[$postitem][$j] = '!!1!!'.$_POST[$postitem][$j];
								}
								$j++;
							}
						}// End hack
						$_POST[$postitem] = ab_arrayEncode($_POST[$postitem]);
						$_POST[$postitem] = ab_serialize($_POST[$postitem]);
					}
					$sql.= ' '.$postitem."='".$wpdb->escape($_POST[$postitem])."'";
				}// endif

			}// end foreach
			if (isset($_POST['_fid'])) {
				$sql.= " WHERE id=".$wpdb->escape($_POST['_fid']).";";
			}
			$ret = $wpdb->query($sql);
			if ($ret == 0) echo "<!-- SQL: $sql -->";

			// Handle other page updates

		} else {

			// Handle checkboxes and other special items for each page
			if ($_GET['p'] == 'Settings') {
				$_POST['running'] = intval(isset($_POST['running']));
				$_POST['uselinkinfo'] = intval(isset($_POST['uselinkinfo']));
				$_POST['useauthorinfo'] = intval(isset($_POST['useauthorinfo']));
				$_POST['updatecheck'] = intval(isset($_POST['updatecheck']));
				$_POST['includeaffil'] = intval(isset($_POST['includeaffil']));
				$_POST['addlink'] = intval(isset($_POST['addlink']));
				$_POST['syndicationsource'] = intval(isset($_POST['syndicationsource']));
				$_POST['respectcopyright'] = intval(isset($_POST['respectcopyright']));
				$_POST['addcopyright'] = intval(isset($_POST['addcopyright']));
				$_POST['respectrobots'] = intval(isset($_POST['respectrobots']));
				$ab_options['interval'] = rand($_POST['mintime'], $_POST['maxtime']) + (time() - $ab_options['lastupdate']) / 100;
			}
			if ($_GET['p'] == 'Tag Options') {
				$_POST['feedtags'] = intval(isset($_POST['feedtags']));
				$_POST['posttags'] = intval(isset($_POST['posttags']));
				$_POST['yahootags'] = intval(isset($_POST['yahootags']));
				$_POST['taggingengine'] = intval(isset($_POST['taggingengine']));
				if (isset($_POST['tags_input'])) $_POST['tags'] = explode(',', $_POST['tags_input']);
			}
			if ($_GET['p'] == 'Filtering') {
				$_POST['filterbytitle'] = intval(isset($_POST['filterbytitle']));
				$_POST['filterbylink'] = intval(isset($_POST['filterbylink']));
				$_POST['skipcaps'] = intval(isset($_POST['skipcaps']));
				$_POST['skipmultiplepunctuation'] = intval(isset($_POST['skipmultiplepunctuation']));
				$_POST['filterbyfile'] = intval(isset($_POST['filterbyfile']));
				$_POST['skipemptylinks'] = intval(isset($_POST['skipemptylinks']));
				$_POST['allowdomain'] = intval(isset($_POST['allowdomain']));
			}
			if ($_GET['p'] == 'Support') {
				$_POST['logging'] = intval(isset($_POST['logging']));
				$_POST['showdebug'] = intval(isset($_POST['showdebug']));
			}
			foreach(array_keys($_POST) as $postitem) {
				if (substr($postitem, 0, 1) <> '_') {
					if (is_array($_POST[$postitem])) {
						$_POST[$postitem] = ab_arrayEncode($_POST[$postitem]);
						$_POST[$postitem] = ab_serialize($_POST[$postitem]);
					}
					$ab_options[$postitem] = $_POST[$postitem];
				}
			}// foreach
			echo '<div id="sn-warning" class="updated fade"><p>Your settings have been saved.</div>';
		}// endif

	}// endif

   /****************************************************************************************
	 ANTIPIRACY NOTIC
	 Note that we do not spend our valuable development resources trying to come up with 
	 foolproof antipiracy scheme. We would rather spend that time adding new features or
	 improving the quality of our software and we would rather provide our customers with
	 full access to unencrypted source code.

	 We realize that this will make it easier to bypass any restrictions we have in place
	 to use this software without paying or distribute it to others. We don't expect to stop
	 piracy of our software but we do ask that if you are using an unlicensed copy that you at
	 least give back in some way through a link to our site, a review on a blog or forum
	 somewhere, offer to do beta testing for us, write up a tutorial, or sign up for
	 our affiliate program and generate some sales for us.

	 Of course, we do prefer that you always purchase a license and in exchange you will get
	 excellent support, access to our customer forums, and we will always make sure you are
	 up-to-date with the latest release.

	 To encourage honesty, integrity, and fairness we are offering the coupon code NONPIRATED
	 that you can use at checkout to get $10 off a single site license or $30 off an unlimited
	 sites license. Please share this coupon code with anyone you want, especially if you
	 are distributing unauthorized copies of our software!
	 *****************************************************************************************/


	// Make sure they have entered their serial number as a soft nag, all features still enabled
	
	

//	if ($_GET['action'] <> 'doreg') {
//		if (strlen($ab_options['sn']) == 0) {
//			if (function_exists('wp_nonce_url')) {
//				$settingslink = wp_nonce_url(admin_url().'admin.php?page=AutoBloggedSettings', 'autoblogged-nav');
//				$settingslink.= '&amp;p=Settings&amp;action=doreg';
//			}
//			echo '<div id="sn-warning" class="updated fade"><p><strong>'.__("Product Registration: ").'</strong>You ha'.'ve not entered your ser'.'ial number. <a href="'.$settingslink.'">Click  here</a> to enter it now.</div>';
//		}
//	}

//	// Check for updates
//	if ($ab_options['updatecheck']) {
//
//		// Only check once every 12 hours
//		if (time() > $ab_options['last_update_check'] + (43200)) {
//			$ab_options['last_update_check'] = time();
//			$result = ab_httpFetch('http://aut'.'oblogged.'.'com/version.htm?re'.'gnum='.urlencode($ab_options['sn']));
//
//			if (empty($result['error'])) {
//				if (version_compare($result['content'], AB_VERSION, ">")) {
//					echo '<div id="update-nag">AutoBlogged version '.$result['content'].' is now available. You can get this update using your original download link.</div>';
//				}
//			}
//		}
//	}
	ab_saveOptions();

	// Check permissions on _debug.log file
	if ($_GET['p'] == 'Support' && $ab_options['showdebug'] == true) {
		$fp = @fopen(dirname(__FILE__).'/_debug.log', 'a');
		if (!$fp) {
			echo '<div id="sn-warning" class="updated fade"><p><strong>'.__("Error: ").'</strong>AutoBlogged cannot write to or create the file _debug.log. Check the permissions on the AutoBlogged plugin directory.</div>';
		}
	}

	// Admin options page header
	echo '<link rel="stylesheet" href="'.get_option('siteurl').'/wp-includes/js/thickbox/thickbox.css" type="text/css" media="all" /> ';
	echo '<link rel="stylesheet" type="text/css" href="'.ab_pluginURL().'/abadmin.css" />'."\r\n";
	?>

	<SCRIPT language="JavaScript">
	<!--
	function d(delurl)
	{ if (confirm("Do you really want to delete this feed?")== true) { window.location=delurl; }}
	//-->
	</SCRIPT>
	<?PHP
}// end function


/**
* Feeds summary admin page
*
* @return void
*/
function ab_showFeedsPage() {
	global $wpdb, $ab_options, $feedtypes;
	ab_adminPageHeader();
	if (version_compare(phpversion(), '5.0.0', '<')){
		echo '<div id="php4-warning" class="updated fade"><p><strong>Warning: </strong> AutoBlogged is not compatible with PHP 4, please update your server to PHP 5 to use AutoBlogged.</div>';
	}

	// First check to see if we are deleting a feed
	if ($_GET['action'] == 'del' && isset($_REQUEST['_fid'])) {
		$sql = 'DELETE FROM '.ab_tableName().' WHERE id='.$wpdb->escape($_GET['_fid']).' LIMIT 1;';
		$ret = $wpdb->query($sql);
	}

	// Load feeds list from DB
	$sql = "SELECT id, title, type, url, enabled FROM ".ab_tableName().';';
	$feeds = $wpdb->get_results($sql, 'ARRAY_A');
	$categories = get_categories('orderby=name&hide_empty=0');
	echo '<div class="wrap"><br/><a href="http://autoblogged.com" target="_blank"><img src="'.ab_pluginURL().'/img/logo.png"/></a>';
	echo '<div id="poststuff" class="metabox-holder has-right-sidebar">';
	$sidebars = array('Feed Processing' => 'ab_MetaFeedsPageSidebar', 'Links' => 'ab_MetaLinksSidebar');
	ab_doSideBar($sidebars, 'autoblogged-feeds');
	ab_OpenMainSection();
	if (function_exists('wp_nonce_url')) {
		$baselink = wp_nonce_url($_SERVER['SCRIPT_URI'].'?page='.$_GET['page'], 'autoblogged-feeds-edit');
	} else {
		$baselink = admin_url().'?page='.$_GET['page'];
	}
	if (sizeof($feeds) > 0) {

		// Loop through each feed
		foreach($feeds as $feed) {
			$feed = ab_arrayStripSlashes($feed);
			echo '<div class="feedswrap">';
			if (empty($feed['title'])) {
				$feedurl = $feed['url'];
				if (strlen($feedurl) > 50) $feedurl = substr($feed['url'], 0, 50).'...';
				if ($feed['type'] > 1) {
					$feedtitle = $feedurl;
				} else {
					$feedtitle = $feedurl;
				}
			} else {
				$feedtitle = $feed['title'];
			}
			echo '<div class="feedheader"> <div class="'.strtolower(str_replace("!", "", str_replace(" ", "", $feedtypes[$feed['type']]))).'">&nbsp;'.$feedtypes[$feed['type']].'&nbsp;</div>';
			if (!$feed['enabled']) {
				echo '&nbsp;<font color="gray"><span style="text-decoration: line-through;">'.$feedtitle.'</span></font>';
			} else {
				echo '&nbsp;&nbsp;'.$feedtitle.'';
			}

			if ($feed['enabled']) {
				$action = "disable";
			} else {
				$action = "enable";
			}
			echo '<div><a class="feedurl" href="'.$baselink.'&amp;p=&amp;action='.$action.'&_fid='.$feed['id'].'"><img style="vertical-align: middle;" src="'.ab_pluginURL().'/img/'.$action.'.png" >&nbsp;'.ucfirst($action).' feed</a>&nbsp;';
			echo '| <a class="feedurl" href="#" onclick="d(\''.$baselink.'&amp;p=Feeds&_fid='.$feed['id'].'&amp;action=del\')"><img style="vertical-align: middle;" src="'.ab_pluginURL().'/img/delete.png" >&nbsp;Delete feed</a>&nbsp;';
			echo '</div></div>';
			echo '<div class="editfeed"><a class="abbutton" href="'.$baselink.'&amp;action=edit&_fid='.$feed['id'].'">&nbsp;Settings</a> ';
			$feed_urls = explode("\r\n", $feed['url']);
			if (count($feed_urls) > 1) {
				echo '&nbsp;&nbsp;<a class="abbutton thickbox" target="_blank" href="'.wp_nonce_url(ab_pluginURL().'/view.php?v=viewer', 'autoblogged-nav').'&fid='.$feed['id'].'&TB_iframe=true&height=600&width=800" >Feed Viewer</a> ';
				echo '&nbsp;&nbsp;<a class="abbutton thickbox" target="_blank" href="'.wp_nonce_url(ab_pluginURL().'/view.php?v=validate', 'autoblogged-nav').'&fid='.$feed['id'].'&TB_iframe=true&height=600&width=800" >Validate Feed</a> ';
			} else {
				echo '&nbsp;&nbsp;<a class="abbutton thickbox" target="_blank" href="htt'.'p:/'.'/viewer.auto'.'blogged'.'.com/?feed='.urlencode(ab_getFeedURL($feed['type'], $feed['url'])).'&type=htm&TB_iframe=true&height=600&width=900" >Feed Viewer</a> ';
				echo '&nbsp;&nbsp;<a class="abbutton thickbox" target="_blank" href="http://feed1.w3.org/check.cgi?url='.urlencode(ab_getFeedURL($feed['type'], $feed['url'])).'&type=htm&TB_iframe=true&height=600&width=900" >Validate Feed</a> ';
			}
			$process_now_url = ab_pluginURL().'/run.php?auth='.ab_authKey().'&fid='.$feed['id'].'&show=v&action=manual&TB_iframe=true&height=600&width=800';
			echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a class="abbutton thickbox" href="'.$process_now_url.'"><img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/refresh.png">&nbsp;Process Now</a>&nbsp;';
			echo '<br/></div></div>';
		}
		// foreach
		echo '<div class="feedswrap"><a class="feedurl" href="'.$baselink.'&amp;action=edit"><img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/add.png"/> Add New Feed</a></div><br/><br/>';
	} else {
		echo '<div class="feedswrap" "><div ><div class="feedheader">Getting Started</div><font color="gray">You currently do not have any feeds set up. AutoBlogged Automatically adds posts to your blog based on the RSS feeds or searches you set up. To get started adding your first feed, <a href="'.$baselink.'&amp;action=edit">click here</a><br /><br /></font></div></div>';
	} //end if
	
	do_action('autoblogged_main_page');
	echo '</div></div></div></div></div></div>';
}

/**
* Feeds page meta sidebar
*
* @return void
*/
function ab_MetaFeedsPageSidebar() {
	global $ab_options;
	if (function_exists('wp_nonce_url')) $navlink = wp_nonce_url($_SERVER['SCRIPT_URI'].'?page='.$_GET['page'], 'autoblogged-nav');
	echo '<div id="feedssidebar">';
	echo '';
	echo '<div id="previewview"><img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/add.png"/>&nbsp;&nbsp;<a class="feedurl" href="'.$navlink.'&amp;action=edit">Add New Feed</a></div>';
	echo '<br />';
	$process_now_url = ab_pluginURL().'/run.php?auth='.ab_authKey().'&show=v&action=manual&TB_iframe=true&height=600&width=800';
	echo '<img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/refresh.png" />&nbsp;&nbsp;<a class="feedurl thickbox" href="'.$process_now_url.'" >Process all feeds now</a><br />';
	$process_now_url = ab_pluginURL().'/run.php?auth='.ab_authKey().'&show=v&action=preview&TB_iframe=true&height=600&width=800';
	echo '<img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/preview.png" />&nbsp;&nbsp;<a class="feedurl thickbox" href="'.$process_now_url.'">Preview feed processing</a><br /><br />';
	echo '<p class="curtime">Current server time: <b>'.date("g:i a").'</b><br />';
	echo 'Feeds last processed: <b>'.date("g:i a", (int)$ab_options['lastupdate']).'</b><br />';
	echo 'Next scheduled run: <b>'.date("g:i a", (int)$ab_options['lastupdate'] + (int)($ab_options['interval'] * 100)).'</b><br />';
	echo '<!-- '. date("g:i a", get_transient('AutoBlogged_LastRun')) . ' -->';
	if ($ab_options['running'] == false) {
		echo '<i>Feed processing is currently <a href="'.wp_nonce_url(admin_url('admin.php').'?page=AutoBloggedSettings&amp;p=Settings', 'autoblogged-nav').'">paused</a></i><br />';
	}
	if (USE_JOURNAL) echo '<br /><img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/history.png" />&nbsp;<a href="'.wp_nonce_url(ab_pluginURL().'/journal.php?height=550&width=1000', 'autoblogged-nav').'" class="thickbox feedurl">View history...</a></b></p><br />';
	echo '<p class="submit">';
	echo 'AutoBlogged Version: '.AB_VERSION;
	echo '<!-- Theme: '.get_current_theme().'-->';
	echo '</p></div>';
}


/**
* Edit feed admin options page
*
* @return void
*/
function ab_showEditFeedPage() {
	global $wpdb;
	global $feedtypes;
	ab_adminPageHeader();
	echo '<div class="wrap"><h2><a href="http://autoblogged.com" target="_blank"><img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/logo-sm.png"/></a>&nbsp;&nbsp;Feed Settings</h2>';
	echo '<div id="poststuff" class="metabox-holder has-right-sidebar">';
	if (array_key_exists('_submit_check', $_POST)) check_admin_referer('autoblogged-feeds-edit');
	if (empty($_REQUEST['_fid'])) {

		// Load defaults if we are adding a new feed
		require (ab_plugin_dir().'/defaults.php');
		$feeds = Array();
		$feeds[] = Array();
		$feeds[0] = array("id" => '', "enabled" => $enabled, "type" => $feed_type, "url" => $keywords_or_feed_url, "title" => $title, "poststatus" => $default_status, "category" => $assign_posts_to_this_category, "addothercats" => $add_additional_categories, "addcatsastags" => $add_categories_as_tags, "tags" => $additional_tags, "saveimages" => $save_full_images, "createthumbs" => $create_thumbnails, "playerwidth" => $video_width, "playerheight" => $video_height, "includeallwords" => $all_these_words, "includeanywords" => $any_of_these_words, "includephrase" => $the_exact_phrase, "includenowords" => $none_of_these_words, "customfield" => $custom_fields, "customfieldvalue" => $custom_values, "templates" => $feed_post_template, "searchfor" => $search_for_patterns, "replacewith" => $replace_with_patterns, "uselinkinfo" => $use_link_info, "useauthorinfo" => $use_author_info, "customplayer" => $custom_player_url, "randomcats" => $randomly_add_selected_categories, "usepostcats" => $use_categories_from_original, "addpostcats" => $add_categories_from_original, "author" => $author, "alt_author" => $alternate_author_if_doesnt_exist, "schedule" => $feed_processing_schedule, "updatefrequency" => $feed_processing_every_x_updates, "post_processing" => $post_processing, "max_posts" => $max_posts_per_update, "posts_ratio" => $randomly_include_x_percent_of_posts, "last_updated" => '', "update_countdown" => '', "last_ping" => '', "usefeeddate" => $use_date_from_feed, "posttype" => $post_type);
	} else {

		// Load the specified feed
		$sql = "SELECT * FROM ".ab_tableName().' WHERE id='.$wpdb->escape($_REQUEST['_fid']).';';
		$feeds = $wpdb->get_results($sql, 'ARRAY_A');
	}
	$categories = Array();
	$blogcategories = get_categories('orderby=name&hide_empty=0');
	foreach($blogcategories as $cat) {
		$categories[] = $cat->cat_name;
	}

	// There should only be one feed in this loop
	foreach($feeds as $feed) {
		if (empty($_GET['_fid'])) {
			echo '<form action="admin.php?page='.$_GET['page'].'&amp;p=Feeds&amp;action=add" method="post">';
		} else {
			echo '<form action="admin.php?page='.$_GET['page'].'&amp;p=Feeds&_fid='.$feed['id'].'" method="post">';
			$feed = ab_arrayStripSlashes($feed);

			// Do some theme checks and make recommendations if necessary
			$themedata = get_theme(get_current_theme());
			if (function_exists('p75_videoPosting') && stristr($themedata['Author'], 'press75')) {

				// === Newer Press75 Themes
				if (!$feed['saveimages']) {
					echo '<div id="sn-warning" class="updated fade"><p><strong>Note:</strong>  If you are using Press75 themes, we highly recommend that you save all images from this feed locally, which you currently are not doing. </p><p>To fix this, scroll down to the Images section and select <i>Save local copies of all images in the feed</i>.</p></div>';
				}
			} else {
				$theme = get_current_theme();
				switch ($theme) {
					case 'Arthemia Premium':
					if (!$feed['saveimages']) {
						echo '<div id="sn-warning" class="updated fade"><p><strong>Note:</strong>  If you are using the Arthemia Premium theme\'s auto thumbnail feature, you must save all images from this feed locally, which you currently are not doing. </p><p>To fix this, scroll down to the Images section and select <i>Save local copies of all images in the feed</i>.</p><p>See <a href="http://autoblogged.com/kb/themes/colorlabs-project-arthemia" target="_blank">this article</a> for more information about using AutoBlogged with the Arthemia theme.</p></div>';
					}
					break;
					case 'Thesis':
					case 'Thesis/thesis_18':
					case 'Thesis/thesis_17':
					case 'Thesis/thesis_16':
					if (!$feed['saveimages']) {
						echo '<div id="sn-warning" class="updated fade"><p><strong>Note:</strong>  If you are using the DIYThemes Thesis theme, you must save all images from this feed locally, which you currently are not doing. </p><p>To fix this, scroll down to the Images section and select <i>Save local copies of all images in the feed</i>.</p><p>See <a href="http://autoblogged.com/kb/themes/diythemes-thesis/" target="_blank">this article</a> for more information about using AutoBlogged with the Thesis theme.</p></div>';
					}
					break;
					case 'solid-dust':
					case 'Advanced-Newspaper':
					case 'transcript':
					case 'Blognews':
					if (!$feed['saveimages']) {
						echo '<div id="sn-warning" class="updated fade"><p><strong>Note:</strong>  Based on the theme you are currently using, you must save all images from this feed locally, which you currently are not doing. </p><p>To fix this, scroll down to the Images section and select <i>Save local copies of all images in the feed</i>.</p></div>';
					}
					break;
				}
			}
		}
		if (function_exists('wp_nonce_field')) $wpnonce = wp_nonce_field('autoblogged-feeds-edit');
		echo '<input type="hidden" name="_submit_check" value="1" />'.$wpnonce;
		echo '<input type="hidden" name="_fid" value="'.$feed['id'].'"/>';
		echo '<input type="hidden" name="enabled" value="'.$feed['enabled'].'"/>';
		$sidebars = array('Feed' => 'ab_MetaEditFeedSidebar', 'Links' => 'ab_MetaLinksSidebar');
		?>
		<script type="text/javascript">

		function setfeedtype()
		{
			if(document.getElementById('type').selectedIndex==0)
			{
				document.getElementById('lblurl').innerHTML='RSS feed URL:';
			}	else {
				document.getElementById('lblurl').innerHTML='Search keywords:';

			}
		}

		function setaltauthor()
		{
			if(document.getElementById('author').selectedIndex==1)
			{
				document.getElementById('alt_author').disabled=false;
				document.getElementById('lblalt_author').style.color='black';
			}	else {
				document.getElementById('alt_author').disabled=true;
				document.getElementById('lblalt_author').style.color='gray';

			}
		}
		</script>
		<?PHP
		ab_doSideBar($sidebars, 'autoblogged-feeds', $feed);
		ab_OpenMainSection();

		// General Settings
		echo ab_makeBoxStart("General Settings");
		echo '<table class="editform" width="100%">';
		echo ab_makeTextInput('title', $feed['title'], 60, 'Title (Optional)', 'This is an optional name you can assign to help manage your feeds. Leave blank to have a title automatically assigned.');
		if ($feed['type'] == '1') {
			$desc = 'RSS feed URL';
		} else {
			$desc = 'Search keywords';
		}
		echo '<tr><td>&nbsp;</td></tr>';
		
		echo ab_makeSelect('type', $feedtypes, $feedtypes[$feed['type']], 'Feed Type', '', null, 'setfeedtype');

		//echo ab_makeTextInput('url', htmlentities($feed['url']), 60, $desc, 'If Feed Type is RSS Feed, enter the feed URL here, otherwise enter search keywords.');
		echo ab_makeWideTextArea('url', htmlentities($feed['url']), 10, $desc, 'Enter one feed URL or search term per line');
		echo '<tr><td>&nbsp;</td></tr>';
		echo '</table>';
		echo '<table class="editform">';

		// If v2.9 or later get custom post types
		global $wp_version;
		if (version_compare($wp_version, '2.9', '>=')) {
			$post_types = get_post_types();
			foreach($post_types as $post_type) {
				if ($post_type <> 'mediapage' && $post_type <> 'revision' && $post_type <> 'attachment' && $post_type <> 'nav_menu_item') {
					$pt = get_post_type_object($post_type);
			
					$post_type_labels[$pt->labels->name][0] = $pt->labels->singular_name;
					$post_type_labels[$pt->labels->name][1] = $pt->name;
				}
			}
			
			$pt = get_post_type_object($feed['posttype']);		
			$post_type = $pt->labels->singular_name;
			echo ab_makeSelect('posttype', $post_type_labels, $post_type, 'Post Type');
		}
		echo ab_makeSelect('poststatus', Array("Publish", "Pending", "Draft", "Private"), $feed['poststatus'], 'Status for new posts', '');
		echo '<br/>';
		echo ab_makeCheckBox('usefeeddate', $feed['usefeeddate'], "Post date", "Use original post date", '');
		echo '</table>';
		echo ab_makeBoxClose();

		// Post processing
		echo ab_makeBoxStart("Feed Processing");
		echo '<table class="editform" width="100%">';
		$options = array('With every scheduled update', 'After every <input name="updatefrequency" type="text" style="width: 30px" value="'.stripslashes(attribute_escape($feed['updatefrequency'])).'"/>&nbsp;scheduled updates', 'Manually, using an external cron, or when notified via XML-RPC ping');
		echo '<tr valign="top"><td><p>Process this feed:</p></td><td><p>';
		echo ab_makeRadioOnly('schedule', $feed['schedule'], $options, '');
		echo '</p></td></tr>';
		$url = ab_pluginURL() . '/run.php?auth='.ab_authKey();
		echo '<tr><td>&nbsp;</td><td><p>Cron URL: <code>'.$url.'</code> <a href="'.wp_nonce_url(ab_pluginURL().'/help.php?height=430&width=450&t=cron&fid='.$feed['id'], 'autoblogged-nav').'" class="thickbox">More Info</p></a></td></tr>';
		echo '<tr><td>&nbsp;</td></tr><tr valign="top"><td><p>When processing this feed:&nbsp;&nbsp;</p></td><td><p>';
		$options = array('Include all posts', 'Only include the first <input name="max_posts" type="text" style="width: 30px" value="'.stripslashes(attribute_escape($feed['max_posts'])).'"/> posts from each feed', 'Randomly include <input name="posts_ratio" type="text" style="width: 40px" value="'.stripslashes(attribute_escape($feed['posts_ratio'])).'"/></label>% of all posts');
		echo ab_makeRadioOnly('post_processing', $feed['post_processing'], $options, '');
		echo '</p></td></tr></table>'.ab_makeBoxClose();

		// Tags
		echo ab_makeBoxStart("Tags");;
		echo '<p>AutoBlogged will randomly add one or more of the following tags to each post in this feed: </p>';
		$tags = ab_unserialize($feed['tags']);
		if (!is_array($tags)) $tags = array();
		?>

		<div class="tagsdiv" id="post_tag">
		<div class="jaxtag">
		<textarea name="tags_input" class="the-tags" id="tags_input"><?PHP echo implode(",", $tags); ?></textarea>
		</div>
		<br /><font size="1" color="SlateGray">Separate tags with commas.</font>
		</div>

		<?php
		echo ab_makeBoxClose();

		// Categories
		echo ab_makeBoxStart("Categories", "categorydiv");
		echo 'Assign posts to these categories:';
		?>

		<div id="categories-pop" class="tabs-panel" style="display: none;">
		<ul id="categorychecklist-pop" class="categorychecklist form-no-clear" >
		<?php $popular_ids = wp_popular_terms_checklist('category'); ?>
		</ul>
		</div>
		<div style="padding : 4px; width : 300px; height : 180px; overflow : auto;
		<div id="categories-all" class="tabs-panel">
		<ul id="categorychecklist" class="list:category categorychecklist form-no-clear">

		<?php
		if (function_exists('wp_category_checklist')) {
		wp_category_checklist('', false, ab_unserialize($feed['category']), $popular_ids);
		} else {
		global $checked_categories;
		$cats = array();
		$checked_categories = ab_unserialize($feed['category']);
		dropdown_categories();
		}
		?>

		</ul>
		</div>

		<?PHP
		echo '<table class="editform" width="75%">';
		echo '<tr><td>&nbsp;</td></tr>';
		echo '<tr valign="top"><td scope="row"><p>With the above selected categories:</p></td><td><p>';
		echo ab_makeRadioOnly('randomcats', $feed['randomcats'], array('Add all to each post', 'Randomly add one or more to each post'), '');
		echo '</p></td><tr><td>&nbsp;<br /></td></tr>';
		echo '<tr valign="top"><td scope="row"><p>When the original content has<br />categories already assigned:</p></td><td><p>';
		echo ab_makeCheckBoxOnly('usepostcats', $feed['usepostcats'], 'Use these categories if they exist in your blog', '').'<br />';
		echo ab_makeCheckBoxOnly('addpostcats', $feed['addpostcats'], 'Add these categories to your blog if they don\'t exist', '').'</p></td></tr>';
		echo '<tr><td>&nbsp;</td></tr>';
		echo '<tr valign="top"><td scope="row"><p>If the name of any of your blog<br/>categories appear in the post content:</p></td><td><p>';
		echo ab_makeCheckBoxOnly('addothercats', $feed['addothercats'], 'Also assign these categories to the post', '').'<br />';
		echo ab_makeCheckBoxOnly('addcatsastags', $feed['addcatsastags'], 'Add these categories as post tags', '').'<p></td></tr>';
		echo '</table>'.ab_makeBoxClose();

		// Custom Taxonomies
		$taxonomies = get_taxonomies('', 'names');
		$taxonomies = array_diff($taxonomies, array('nav_menu'));
		echo ab_makeBoxStart("Custom Taxonomies", '', true);
		echo '<p>If you use custom taxonomies on your blog you can set those here based on feed contents. To create and manage custom taxonomies, you will need to install <a href="http://wordpress.org/extend/plugins/search.php?q=taxonomies" target="_blank">an external plugin</a>.</p>';
		echo '<table>';
		echo ab_makeValuePairTable(array("Custom Taxonomy", "Custom Taxonomy Value"), ab_unserialize($feed['customtaxonomy']), ab_unserialize($feed['customtaxonomyvalue']), null, $taxonomies);
		echo '</table>'.ab_makeBoxClose();

		// Authors
		$userlist = array();
		$users = $wpdb->get_results("SELECT display_name FROM $wpdb->users ORDER BY display_name");
		if (is_array($users)):
		foreach($users as $user):
		$userlist[] = $user->display_name;
		endforeach;
		endif;
		echo ab_makeBoxStart("Authors");
		echo '<table>';
		echo ab_makeSelect('author', array_merge(array(RANDOM_AUTHOR, AUTHOR_FROM_FEED), $userlist), $feed['author'], 'Set author for new posts', '', '', 'setaltauthor');
		if ($feed['author'] == AUTHOR_FROM_FEED) {
			$altauthorenabled = true;
		} else {
			$altauthorenabled = false;
		}
		echo ab_makeSelect('alt_author', array_merge(array('', ADD_AUTHOR, SKIP_POST, RANDOM_AUTHOR), $userlist), $feed['alt_author'], 'If using author from feed<br />and that author doesn\'t exist in blog', '', true, null, $altauthorenabled);
		echo '</td></tr></table><br /></div></div>';

		// Images
		echo ab_makeBoxStart("Images");
		echo '<table>';
		echo '<tr valign="top"><td scope="row"><p>Image Options: </p></td><td><p>';
		echo '<tr><td>'.ab_makeRadioOnly('saveimages', $feed['saveimages'], array('Do not save images locally', 'Save local copies of all images in the feed', 'Save local copy of first image only'), '');
		echo ab_makeCheckBoxOnly('createthumbs', $feed['createthumbs'], 'Create local thumbnails for each image', 'Note that if you save full-size images locally autoblogged will always create thumbnails.').'</p></td></tr>';
		echo '</table><br />';
		echo '<a href="'.get_option('siteurl').'/wp-admin/options-media.php">Click here</a> to configure WordPress thumbnail settings.'.ab_makeBoxClose();

		// Video
		echo ab_makeBoxStart("Embedded Video Player");
		echo '<table>';
		echo ab_makeTextInput('playerwidth', $feed['playerwidth'], 10, 'Video width', '');
		echo ab_makeTextInput('playerheight', $feed['playerheight'], 10, 'Video height', '');
		echo '<tr><td>&nbsp;</td></tr>';
		echo '</table>'.ab_makeBoxClose();

		// Filtering
		echo ab_makeBoxStart("Filtering", '', true);
		echo '<h4>Include posts that contain (separate words with commas):</h4>';
		echo '<table>';
		echo ab_makeTextInput('includeallwords', $feed['includeallwords'], 70, 'All these words', '');
		echo ab_makeTextInput('includeanywords', $feed['includeanywords'], 70, 'Any of these words', '');
		echo ab_makeTextInput('includephrase', $feed['includephrase'], 70, 'The exact phrase', '');
		echo ab_makeTextInput('includenowords', $feed['includenowords'], 70, 'None of these words', '');
		echo '</table>'.ab_makeBoxClose();
		echo '</div></div></div><br /><br /><div class="wrap"><div id="poststuff"><h2>Advanced Settings</h2>';

		// Custom Fields
		echo ab_makeBoxStart("Custom Fields", '', true);
		echo '<p>Set these additional custom fields to use in post templates or as custom fields in WordPress.</p>';
		echo '<table>';
		echo ab_makeValuePairTable(array("Custom Field", "Custom Field Value"), ab_unserialize($feed['customfield']), ab_unserialize($feed['customfieldvalue']));
		echo '</table>'.ab_makeBoxClose();

		// Post Templates
		echo ab_makeBoxStart("Post Templates", '', true);
		echo '<p>Templates determine how the feed will appear in the blog posts. For more information on post templates, see the <a href="http://autoblogged.com/online-help/advanced-usage/post-template-reference/" target="_blank">Template Reference</a>.</p>';
		echo '<table class="form-table">';
		echo '<tr><td colspan="2"><textarea name="templates" rows="12" style="width: 100%" >'.$feed['templates'].'</textarea></td></tr>';
		echo '</table>'.ab_makeBoxClose();

		// Search and Replace
		echo ab_makeBoxStart("Search and Replace", '', true);
		echo '<p>Here you can add any strings or regular expressions to search and replace in feed items before adding them as a post. You can use this to change words, replace affiliate IDs, rewrite URLs, fix invalid feeds, etc. Seach items may contain regular expressions and replace items may refer to search matches such as $1, $2, etc.</p>';
		echo ab_makeValuePairTable(array("Search for", "Replace with"), ab_unserialize($feed['searchfor']), ab_unserialize($feed['replacewith']), true);
		echo '</table>'.ab_makeBoxClose();
		
		do_action('autoblogged_edit_feeds_page');
	}
	echo '</table></form></div></div></div></div>';
}

/**
* Edit feeds page meta sidebar
*
* @param  array $feed 
* @return void
*/
function ab_MetaEditFeedSidebar($feed = null) {
	global $ab_options;
	if (function_exists('wp_nonce_url')) $navlink = wp_nonce_url(admin_url().'?page='.$_GET['page'], 'autoblogged-nav');
	echo '<div id="feedsidebar">';
	if (!empty($feed['id'])) {
		$process_now_url = ab_pluginURL().'/run.php?auth='.ab_authKey().'&fid='.$feed['id'].'&show=v&action=manualTB_iframe=true&height=600&width=800';
		echo '<br/><img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/refresh.png" />&nbsp;&nbsp;<a class="feedurl thickbox" href="'.$process_now_url.'">Process this feed now</a><br />';
		$process_now_url = ab_pluginURL().'/run.php?auth='.ab_authKey().'&fid='.$feed['id'].'&show=v&action=previewTB_iframe=true&height=600&width=800';
		echo '<img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/preview.png" />&nbsp;&nbsp;<a class="feedurl thickbox" href="'.$process_now_url.'">Preview this feed now</a><br />';
		echo '<p>&nbsp;</p>';
		if ($feed['enabled']) {
			$action = "disable";
		} else {
			$action = "enable";
		}
		echo '<img style="vertical-align: middle;" src="'.ab_pluginURL().'/img/'.$action.'.png" />&nbsp;&nbsp;<a class="feedurl" href="'.$navlink.'&amp;p=&amp;action='.$action.'&_fid='.$feed['id'].'">'.ucfirst($action).' this feed</a><br />';
		echo '<img style="vertical-align: middle;"  src="'.ab_pluginURL().'/img/delete.png" />&nbsp;&nbsp;<a class="feedurl" href="#" onclick="d(\''.$navlink.'&amp;p=Feeds&_fid='.$feed['id'].'&amp;action=del\')">Delete this feed</a>';
		echo '<p>&nbsp;</p>';
	}
	echo '<p class="curtime">Current server time: <b>'.date("g:i a").'</b><br />';
	echo 'Feed last processed: <b>'.date("g:i a", (int)$feed['last_updated']).'</b><br />';
	echo 'Next scheduled run: <b>'.date("g:i a", $ab_options['lastupdate'] + ($ab_options['interval'] * 100)).'</b><br />';
	if ($ab_options['running'] == false) {
		echo '<i>Feed processing is currently <a href="'.wp_nonce_url(admin_url('admin.php').'?page=AutoBloggedSettings&amp;p=Settings', 'autoblogged-nav').'">paused</a></i><br />';
	}
	if (USE_JOURNAL) echo '<br /><img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/history.png" />&nbsp;<a href="'.wp_nonce_url(ab_pluginURL().'/journal.php?height=550&width=1000', 'autoblogged-nav').'" class="thickbox feedurl">View history...</a></b></p><br />';
	echo '<div class="clear"></div><div id="major-publishing-actions">';
	echo '<input type="submit" name="_Submit" id="publish" value="Save Changes" tabindex="4" class="button-primary" />';
	echo '</div></div>';

	//echo '</div>';

}

/**
* Options page meta sidebar
*
* @return void
*/
function ab_MetaOptionPagesSidebar() {
	echo '<div id="major-publishing-actions">';
	echo '<div class="clear"></div><div id="major-publishing-actions">';
	echo '<input type="submit" name="_Submit" id="publish" value="Save Changes" tabindex="4" class="button-primary" />';
	echo '</div></div>';
}


/**
* Tag Options admin page
*
* @return void
*/
function ab_showTagOptionsPage() {
	global $ab_options;
	ab_adminPageHeader();
	?>
	<script type="text/javascript">

	function enableyahooid()
	{
		if(document.getElementById('yahootags').checked==false)
		{
			document.getElementById('yahooappid').disabled=true;

		}	else {
			document.getElementById('yahooappid').disabled=false;
		}
	}
	</script>
	<?PHP
	echo '<div class="wrap"><h2><a href="http://autoblogged.com" target="_blank"><img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/logo-sm.png"/></a>&nbsp;&nbsp;Tag Options</h2>';
	echo '<div id="poststuff" class="metabox-holder has-right-sidebar">';
	if (array_key_exists('_submit_check', $_POST)) check_admin_referer('autoblogged-tag-options');
	echo '<form action="admin.php?page='.$_GET['page'].'&amp;p=Tag Options'.$feed['id'].'" method="post">';
	if (function_exists('wp_nonce_field')) $wpnonce = wp_nonce_field('autoblogged-tag-options');
	echo '<input type="hidden" name="_submit_check" value="1" />'.$wpnonce;
	if (function_exists('wp_nonce_url')) $navlink = wp_nonce_url(admin_url().'?page='.$_GET['page'], 'autoblogged-nav');
	$sidebars = array('Feeds' => 'ab_MetaOptionPagesSidebar', 'Links' => 'ab_MetaLinksSidebar');
	ab_doSideBar($sidebars, 'autoblogged-feeds');
	ab_OpenMainSection();

	// General Settings
	echo ab_makeBoxStart("General Settings");
	echo '<table>';
	echo ab_makeTextInput('mintaglen', $ab_options['mintaglen'], 10, 'Minimum Tag Length', '');
	echo ab_makeTextInput('maxtaglen', $ab_options['maxtaglen'], 10, 'Maximum Tag Length', '');
	echo ab_makeTextInput('maxtags', $ab_options['maxtags'], 10, 'Maximum Tags per Post', '');
	echo '</table>'.ab_makeBoxClose();

	// Tag Sources
	echo ab_makeBoxStart("Tag Sources");
	echo '<table>';
	echo '<tr valign="top"><td><p>Sources for post tags:</p></td><td>';
	echo ab_makeCheckBoxOnly('feedtags', $ab_options['feedtags'], 'Use original tags from feed', '').'<br />';
	echo ab_makeCheckBoxOnly('taggingengine', $ab_options['taggingengine'], 'Use internal tagging engine to add tags from content', '').'<br />';
	echo ab_makeCheckBoxOnly('posttags', $ab_options['posttags'], 'Visit source URL to extract additional tags', '').'<br />';
	echo ab_makeCheckBoxOnly('yahootags', $ab_options['yahootags'], 'Get tags using Yahoo! API (requires Application ID)', '', 'enableyahooid').'</td></tr>';
	echo '<tr><td>&nbsp;</td></tr>';
	echo ab_makeTextInput('yahooappid', $ab_options['yahooappid'], 70, 'Yahoo! Application ID', 'If you don\'t have an application ID, you can get one <a target="_blank" href="http://developer.yahoo.com/wsregapp/index.php">here</a>', '', $ab_options['yahootags']);
	echo '</table>'.ab_makeBoxClose();

	// Tags
	echo ab_makeBoxStart("Tags");;
	echo '<p>AutoBlogged will randomly add one or more of the following tags to each post in this feed:</p>';
	$tags = $ab_options['tags'];
	if (!is_array($tags)) {
		$tags = ab_unserialize($ab_options['tags']);
	} else {
		$tags = $ab_options['tags'];
	}
	if (!is_array($tags)) {
		$tags = array();
	}
	?>

	<div class="tagsdiv" id="post_tag">
	<div class="jaxtag">
	<textarea name="tags_input" class="the-tags" id="tags_input"><?PHP echo implode(",", $tags); ?></textarea>
	</div>
	<br /><font size="1" color="SlateGray">Separate tags with commas.</font>

	</div>



	<?php
	echo ab_makeBoxClose();

	// Tag filtering
	echo ab_makeBoxStart("Tag Filtering");
	echo ab_makeWideTextArea('notags', $ab_options['notags'], 5, '', 'Do not use any of the following words as tags.  If you see tags appearing in your posts that you do not want, add those tags here', 'Add one per line or on a single line separated by commas. Note that this will not delete existing tags assigned to posts.').ab_makeBoxClose();
	echo '</table>';
	
	do_action('autoblogged_tag_options_page');
	
	echo '</form></div></div></div></div>';
}


/**
* Settings admin page
*
* @return void
*/
function ab_showSettingsPage() {
	global $ab_options;
	ab_adminPageHeader();
	?>
	<script type="text/javascript">
	function enableaffil()
	{
		if(document.getElementById('addlink').checked==false)
		{
			document.getElementById('includeaffil').checked=false;
			document.getElementById('includeaffil').disabled=true;
			document.getElementById('lblincludeaffil').style.color="gray";
		}	else {
			document.getElementById('includeaffil').disabled=false;
			document.getElementById('lblincludeaffil').style.color="black";

		}
	}
	</script>
	<?PHP


	echo '<div class="wrap"><h2><a href="http://autoblogged.com" target="_blank"><img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/logo-sm.png"/></a>&nbsp;&nbsp;Settings</h2>';
	echo '<div id="poststuff" class="metabox-holder has-right-sidebar">';
	if (array_key_exists('_submit_check', $_POST)) check_admin_referer('autoblogged-settings');
	echo '<form name="settings" action="admin.php?page='.$_GET['page'].'&amp;p=Settings'.$feed['id'].'" method="post">';
	if (function_exists('wp_nonce_field')) $wpnonce = wp_nonce_field('autoblogged-settings');
	echo '<input type="hidden" name="_submit_check" value="1" />'.$wpnonce;
	if (function_exists('wp_nonce_url')) $navlink = wp_nonce_url(admin_url().'?page='.$_GET['page'], 'autoblogged-nav');
	$sidebars = array('Settings' => 'ab_MetaOptionPagesSidebar', 'Links' => 'ab_MetaLinksSidebar');
	ab_doSideBar($sidebars, 'autoblogged-feeds');
	ab_OpenMainSection();

	// Registration
	echo ab_makeBoxStart("Registration");
	echo '<table>';
	if ($_GET['action'] == 'doreg') $backcolor = "#FFFFCC";
	echo ab_makeTextInput('sn', 'AB28-5182-100-0000', 50, 'Serial Number', '', $backcolor, false);
	echo ab_makeCheckBox('updatecheck', $ab_options['updatecheck'], 'Updates', 'Automatically check for newer versions of AutoBlogged.<br /><br />', '');
	echo ab_makeCheckBox('addlink', $ab_options['addlink'], 'Include Link', 'Link to AutoBlogged.com in your blog footer.', '', 'enableaffil');
	echo ab_makeCheckBox('includeaffil', $ab_options['includeaffil'], '', 'Include your AutoBlogged affiliate id in link:', '', null, $ab_options['addlink']);
	echo ab_makeTextInput('affilid', $ab_options['affilid'], 10, 'Affiliate ID', 'How to find your <a href="'.wp_nonce_url(ab_pluginURL().'/help.php?&height=430&width=450&t=affil', 'autoblogged-nav').'" class="thickbox">affiliate id.</a>');
	echo '</table>'.ab_makeBoxClose();

	// General Options
	echo ab_makeBoxStart("General Options");
	echo '<table>';
	echo ab_makeCheckBox('running', $ab_options['running'], 'AutoBlogged Enabled', 'Uncheck this if you wish to pause AutoBlogged.', '');
	echo ab_makeTextInput('mintime', $ab_options['mintime'], 10, 'Minimum time between updates', '(minutes)');
	echo ab_makeTextInput('maxtime', $ab_options['maxtime'], 10, 'Maximum time between updates', '(minutes)');
	echo '</table>'.ab_makeBoxClose();

	// Excerpts
	echo ab_makeBoxStart("Excerpts");
	echo '<table>';
	echo '<tr colspan="2"><td><p>When making excerpts:<br />Randomly use between the first ';
	echo '<input name="minexcerptlen" type="text" size="3" value="'.stripslashes(attribute_escape($ab_options['minexcerptlen'])).'" /> and ';
	echo '<input name="maxexcerptlen" type="text" size="3" value="'.stripslashes(attribute_escape($ab_options['maxexcerptlen'])).'" />&nbsp;</p></td></tr>';
	echo '<tr><td>'.ab_makeRadioOnly('excerpt_type', $ab_options['excerpt_type'], array("Words", "Sentences", "Paragraphs"), '');
	echo '</td></tr></table>'.ab_makeBoxClose();

	// WordPress integration
	echo ab_makeBoxStart("WordPress Integration");
	echo '<table>';
	echo ab_makeCheckBox('uselinkinfo', $ab_options['uselinkinfo'], 'WordPress Links', 'Use stored link info if site already appears in links list.', '');
	echo ab_makeCheckBox('useauthorinfo', $ab_options['useauthorinfo'], 'WordPress Authors', 'Use stored author info if author is a registered user.', '');
	echo '</table>'.ab_makeBoxClose();
	
	// Playing Nice
	echo ab_makeBoxStart("Playing Nice");
	echo '<table>';
	echo ab_makeCheckBox('syndicationsource', $ab_options['syndicationsource'], 'Syndication Source', 'Add the syndication-source linktag in page header to give credit to the original source.', 'Read more about <a href="http://www.google.com/support/news_pub/bin/answer.py?answer=191283" target="_blank">syndication-source</a>');
	//echo ab_makeCheckBox('respectcopyright', $ab_options['respectcopyright'], 'Respect Copyright', 'Skip articles if copyright restricts redistribution', '');
	//echo ab_makeCheckBox('addcopyright', $ab_options['addcopyright'], 'Add Copyright', 'Add original author\'s copyright after post if one exists', '');
	echo ab_makeCheckBox('respectrobots', $ab_options['respectrobots'], 'Respect Meta Tags', 'Skip articles if robots meta tag or googlebot meta tag restricts access', '');
	echo '</table>'.ab_makeBoxClose();
	
	// HTTP Options
	echo ab_makeBoxStart("HTTP Options");
	echo '<table>';
	echo ab_makeTextInput('referer', $ab_options['referer'], 40, 'HTTP Referrer', 'All requests made to external sites will use this as the <i>referer</i> string');
	echo ab_makeTextInput('useragent', $ab_options['useragent'], 40, 'HTTP User-Agent', 'All requests made to external sites will use this as the <i>User-Agent</i>. <a href="http://www.user-agents.org/">Click here</a> for a list of User-Agent strings.');
	echo '</table>'.ab_makeBoxClose();

	// RSS Options
	echo ab_makeBoxStart("RSS Retrieval Options");
	echo '<table>';
	echo ab_makeTextInput('rss_cache_timeout', $ab_options['rss_cache_timeout'], 10, 'Cache Timeout', 'Cache RSS requests for this many seconds.');
	if (function_exists('wp_nonce_url')) $navlink = wp_nonce_url(admin_url().'?page='.$_GET['page'], 'autoblogged-nav');
	echo '</table>'.ab_makeBoxClose();
	
	do_action('autoblogged_settings_page');
	
	echo '</div></form></div></div></div>';
}




/**
* Filtering admin page
*
* @return void
*/
function ab_showFilteringPage() {
	global $ab_options;
	global $blog_id;
	ab_adminPageHeader();
	echo '<div class="wrap"><h2><a href="http://autoblogged.com" target="_blank"><img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/logo-sm.png"/></a>&nbsp;&nbsp;Filtering Options</h2>';
	echo '<div id="poststuff" class="metabox-holder has-right-sidebar">';
	if (array_key_exists('_submit_check', $_POST)) check_admin_referer('autoblogged-filtering');
	echo '<form action="admin.php?page='.$_GET['page'].'&amp;p=Filtering'.$feed['id'].'" method="post">';
	if (function_exists('wp_nonce_field')) $wpnonce = wp_nonce_field('autoblogged-filtering');
	echo '<input type="hidden" name="_submit_check" value="1" />'.$wpnonce;
	if (function_exists('wp_nonce_url')) $navlink = wp_nonce_url(admin_url().'?page='.$_GET['page'], 'autoblogged-nav');
	$sidebars = array('Filtering' => 'ab_MetaOptionPagesSidebar', 'Links' => 'ab_MetaLinksSidebar');
	ab_doSideBar($sidebars, 'autoblogged-feeds');
	ab_OpenMainSection();

	// Duplicate Matching
	echo ab_makeBoxStart("Duplicate Posts");
	echo '<table>';
	echo '<tr valign="top"><td><p>Duplicate filtering:&nbsp;&nbsp;&nbsp;</p></td><td>';
	echo ab_makeCheckBoxOnly('filterbytitle', $ab_options['filterbytitle'], 'Match duplicates based on post title', '').'';
	echo ab_makeCheckBoxOnly('filterbylink', $ab_options['filterbylink'], 'Match duplicates based on link', '').'<br />';
	$url = get_option('siteurl').'/wp-admin/plugin-editor.php?file='.ab_dirname().'/'.DUPES_FILENAME.'&plugin='.ab_dirname().'/autoblogged.php';
	echo ab_makeCheckBox('filterbyfile', $ab_options['filterbyfile'], '', 'Match post titles using a local text file', 'Note: <a href="'.$url.'" >Click here</a> to view or edit the posts file.').'</td></tr></table><br />'.ab_makeBoxClose();

	// Title Filtering
	echo ab_makeBoxStart("Title Filtering");
	echo '<table>';
	echo ab_makeTextInput('maxtitlelen', $ab_options['maxtitlelen'], 2, 'Maximum post title length&nbsp;&nbsp;<br />(characters)', '');
	$options = array('Truncate to the nearest word', 'Skip the post');
	echo '<tr valign="top"><td><p>When title is too long:</p></td><td>';
	echo ab_makeRadioOnly('longtitlehandling', $ab_options['longtitlehandling'], $options, '');
	echo '<tr><td>&nbsp;</td></tr>';
	echo ab_makeCheckBox('skipcaps', $ab_options['skipcaps'], 'Title filtering', 'Skip titles in all caps', '');
	echo ab_makeCheckBox('skipmultiplepunctuation', $ab_options['skipmultiplepunctuation'], '', 'Skip titles with multiple consecutive punctuation marks', 'Skip titles such as "What is this?!" or "Amazing!!!!"');
	echo '</td></tr></table>'.ab_makeBoxClose();

	// Other Filtering
	echo ab_makeBoxStart("Other Filters");
	echo '<table>';
	echo '<tr valign="top"><td>';
	echo ab_makeCheckBox('skipemptylinks', $ab_options['skipemptylinks'], '', 'Skip posts with empty links', '');
	echo ab_makeCheckBox('allowdomain', $ab_options['allowdomain'], '', 'Allow posts from your own domain', '');

	//echo ab_makeCheckBox('filterchars', $ab_options['filterchars'], '', 'Remove all non-latin characters', '');
	echo '</td></tr></table>'.ab_makeBoxClose();

	// Blacklists
	echo ab_makeBoxStart("Blacklists");
	echo '<table>';
	echo ab_makeHalfWidthTextArea('domains_blacklist', $ab_options['domains_blacklist'], 10, 'URL Blacklist', 'Reject posts from any of the domains or URL sequences listed here. <br />Add one per line or on a single line separated by commas.');
	echo ab_makeHalfWidthTextArea('keywords_blacklist', $ab_options['keywords_blacklist'], 10, 'Keywords Blacklist', 'Reject posts that contain any of these keywords. <br />Add one per line or on a single line separated by commas.');
	echo '</table>';
	
	do_action('autoblogged_filtering_page');
	
	echo '</form>'.ab_makeBoxClose().'</div></div></div></div>';
}

/**
* Support admin page
*
* @return void
*/
function ab_showSupportPage() {
	global $ab_options, $wpdb, $wp_version;
	ab_adminPageHeader();

	// Handle forced DB upgrade
	if ($_GET['upgrade_db'] == '1') {
		update_option("autoblogged_db_version", '');
		ab_installOnActivation(true);
	}

	// Handle support request e-mail
	if ($_POST['SubmitMessage'] == 'Submit') {
		check_admin_referer('autoblogged-support');

		// Build subject
		$subject = $_POST['su'];
		if (isset($_POST['ti'])) {
			$subject.= ' (#'.$_POST['ti'].')';
		}
		if (empty($_POST['msg'])) {
			echo '<div id="message" class="updated fade"><p>Error: Message field is empty, e-mail message was NOT sent.</p></div>';
		} else {
			$email = AB_SUPPORT_EMAIL;
			$name = $_POST['na'];
			$message = str_replace('&#13', chr(13), $_POST['msg']);
			$message = str_replace('&#10', chr(10), $_POST['msg']);
			$message = str_replace('&#39', chr(39), $_POST['msg']);
			$message = html_entity_decode($message);
			$message_headers = 'From: "'.$name.'"<'.$_POST['em'].'>';
			if (function_exists('filter_var')) $name = filter_var(name, FILTER_SANITIZE_STRING);
			$message = filter_var($message, FILTER_SANITIZE_SPECIAL_CHARS);
		}
		if (intval(isset($_POST['attachinfo']))) {
			$message.= "\n\n\n".'---SYSTEM CONFIGURATION---';
			$message.= "\n".'AutoBlogged Version: '.AB_VERSION;
			$message.= "\n".'PHP Version: '.phpversion();
			$message.= "\n".'WordPress Version: '.$wp_version;
			$message.= "\n".'MySQL Version: '.mysql_get_server_info();
			$message.= "\n".'WordPress Theme: '.get_current_theme();
			$message.= "\n".'Web Server: '.getenv('SERVER_SOFTWARE');
			$message.= "\n".'Serial Number: '.$ab_options['sn'];
		}

		// Attach the configuration if necessary
		if (intval(isset($_POST['attachconfig']))) {
			$attach = '---AUTOBLOGGED CONFIGURATION---';
			$attach.= "\n\n".var_export($ab_options, true);
			$attach.= "\n\n\n".'---FEEDS CONFIGURATION---';
			$sql = "SELECT * FROM ".ab_tableName();
			$feeds = $wpdb->get_results($sql, 'ARRAY_A');
			$attach.= "\n\n".var_export($feeds, true);
		}
		$configfile = dirname(__FILE__).'/sendconfig.txt';
		$cfile = @fopen($configfile, "w");
		if (@fwrite($cfile, $attach) === false) {

			//If we can't write to the file, just append it to the email body
			$message.= "\n\n\n".$attach;
			$mres = wp_mail($email, $subject, $message, $message_headers);
		} else {
			$mres = wp_mail($email, $subject, $message, $message_headers, $configfile);
		}
		@fclose($cfile);
		@unlink($configfile);
		if ($mres) {
			echo '<div id="message" class="updated fade"><p>Support message sent. You should receive an automated response in the next few minutes. If you do not get a response, we may have not properly received the message.</p></div>';
		} else {
			echo '<div id="message" class="updated fade"><p>Error: messages could not be sent. Please visit <a href="http://support.autoblogged.com">support.autoblogged.com</a></p></div>';
		}
	}
	echo '<form action="admin.php?page='.$_GET['page'].'&amp;p=Support'.$feed['id'].'" method="post">';
	if (function_exists('wp_nonce_field')) $wpnonce = wp_nonce_field('autoblogged-tag-options');
	echo '<input type="hidden" name="_submit_check" value="1" />'.$wpnonce;
	echo '<div class="wrap"><h2><a href="http://autoblogged.com" target="_blank"><img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/logo-sm.png"/></a>&nbsp;&nbsp;Technical Support</h2>';
	echo '<div id="poststuff"><div class="post-body">';
	echo ab_makeBoxStart('Diagnostic tools');
	echo '<p>&nbsp;&nbsp;<a href="'.wp_nonce_url(ab_pluginURL().'/diag.php?height=550&width=650', 'autoblogged-nav').'" class="thickbox"><img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/info.png" />&nbsp;View AutoBlogged diagnostics...</a></p>';
	echo '<p>&nbsp;&nbsp;<a href="'.wp_nonce_url(ab_pluginURL().'/diag.php?type=info&height=550&width=650', 'autoblogged-nav').'" class="thickbox"><img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/php.png" />&nbsp;View PHPInfo...</a></p>';
	echo '<p>&nbsp;&nbsp;<a href="'.wp_nonce_url(ab_pluginURL().'/journal.php?height=550&width=1000', 'autoblogged-nav').'" class="thickbox"><img style="vertical-align: text-bottom;" src="'.ab_pluginURL().'/img/history.png" />&nbsp;View AutoBlogged Processing History...</a><br/><br/></p>';
	if (file_exists(dirname(__FILE__).'/_debug.log')) {
		$msg = '<a href="'.wp_nonce_url(ab_pluginURL().'/view.php?f=debug&height=550&width=850', 'autoblogged-nav').'" class="thickbox">View log...</a>';
	} else {
		$msg = '';
	}
	echo ab_makeCheckBox('logging', $ab_options['logging'], '', 'Enable logging to a file when processing feeds.&nbsp;&nbsp;'.$msg, 'This will create a file named _debug.log in the AutoBlogged directory to help troubleshoot problems.');
	echo '<br /><br />';
	echo ab_makeCheckBox('showdebug', $ab_options['showdebug'], '', 'Show verbose debug info.', 'This will include verbose debug messages in the _debug.log file or display them on web pages if you are logged in as a site administrator.');
	echo '<br /><br /><input name="Submit" type="submit" value="Save" />';
	echo '<br /><br /><br />If the AutoBlogged tables were not properly created upon installation, you may manually <a href="admin.php?page='.$_GET['page'].'&amp;upgrade_db=1">create them now</a><br/>';
	echo ab_makeBoxClose();
	
	do_action('autoblogged_support_page');
	
	echo ab_makeBoxStart('Submit Support Request');
	echo 'Please search our  <a href="http://community.autoblogged.com/forums/275308-kb-articles" target="_blank">knowledge base</a> or <a href="http://community.autoblogged.com/forums" target="_blank">forums</a> before sending a support e-mail. To get direct support, send an e-mail to <a href="'.AB_SUPPORT_EMAIL.'">'.AB_SUPPORT_EMAIL.'</a> or use the form below.<br /><br />';
	echo '<form action="admin.php?page='.$_GET['page'].'&amp;p=Support&action=sendmsg" method="post">';
	echo 'Your Name:<br /><input name="na" type="text" style="width: 250px;"/><br /><br />';
	echo 'Your E-Mail Address:<br /><input name="em" type="text" style="width: 250px;" value="'.get_option('admin_email').'" /><br /><br />';
	echo 'Subject:<br /><input name="su" type="text" style="width: 400px;"/><br /><br />';
	echo 'If this is related to an open support ticket, enter that number here: <input name="ti" type="text" style="width: 75px;"/><br /><br />';
	echo 'Message:<br />';
	echo '<textarea name="msg" style="width: 700px; height: 163px"></textarea><br/>';
	echo '<input name="attachinfo" type="checkbox" checked="checked" value="1" />Attach system version info&nbsp;&nbsp;<a href="'.wp_nonce_url(ab_pluginURL().'/help.php?height=430&width=450&t=sysinfo', 'autoblogged-nav').'" class="thickbox">(View)</a>&nbsp;&nbsp;';
	echo '<input name="attachconfig" type="checkbox" />Attach entire AutoBlogged configuration';
	echo '<br /><br /><input name="SubmitMessage" type="submit" value="Submit" />';
	if (function_exists('wp_nonce_field')) $wpnonce = wp_nonce_field('autoblogged-support');
	Echo '<input type="hidden" name="_submit_check" value="1" />'.$wpnonce;
	echo '</form>';
	echo '<br /><br /></div></div>';
	echo ab_makeBoxClose();
	
  
	echo '<br /><br />';
}

// Show the sidebar links


/**
* Short description for function
*
* @return void
*/
function ab_MetaLinksSidebar() {
	$links = array("Online Documentation" => "http://autoblogged.com/online-help/", "Support Forums" => "http://community.autoblogged.com/forums", "AutoBlogged Website" => "http://autoblogged.com", "Become an Affiliate" => "http://autoblogged.com/affiliate-program/", "AutoBlogged on Twitter" => "http://twitter.com/AutoBlogged", "AutoBlogged on Facebook" => "http://www.facebook.com/pages/AutoBlogged/318184872217");
	$feeds = array("Announcements Feed" => "http://community.autoblogged.com/forums/6305-announcements/posts.rss", "Latest Forum Posts" => "http://community.autoblogged.com/forums/6310-technical-support/posts.rss");
	$url = ab_pluginURL();
	$html = '<ul>';
	foreach(array_keys($links) as $link) {
		$html.= '<li><a href="'.$links[$link].'" target="_blank">'.$link.'</a></li>';
	}
	$html.= '</ul><br /><ul>';
	foreach(array_keys($feeds) as $feed) {
		$html.= '<li><a href="'.$feeds[$feed].'" target="_blank">'.$feed.'&nbsp;<img src="'.$url.'/img/rss.png" /></a></li>';
	}
	$html.= '</ul><br /><br /><br />';
	echo $html;
	echo '<br /><br /><br /><br /><br />';
}

/**
* Common opening function for boxes
*
* @param  string  $title  
* @param  string  $div    
* @param  boolean $closed 
* @return string
*/
function ab_makeBoxStart($title, $div = '', $closed = false) {
	if (!isset($div)) $div = str_replace(' ', '', $title).'div';
	$html = '<div id="'.$div.'" class="absetting postbox "';
	if ($closed) $html.= 'if-js-closed';
	$html.= '"><h3>'.$title.'</h3><div class="inside">';
	$html.= "\r\n";
	return $html;
}

/**
* Common closing function for boxes
*
* @return string
*/
function ab_makeBoxClose() {
	$html = '</div></div>';
	return $html;
}

/**
* Common function for checkboxes in a table
*
* @param  string  $field   
* @param  boolean $val     
* @param  string  $title   
* @param  string  $label   
* @param  string  $help    
* @param  string  $onclick 
* @param  boolean $enabled 
* @return string  Returns html
*/
function ab_makeCheckBox($field, $val, $title, $label, $help = '', $onclick = null, $enabled = true) {
	if (strlen($title)) $title.= ': ';
	$html = '<tr valign="top"><td scope="row"><p>'.$title.'</p></td><td><p><label for="'.$field.'" id="lbl'.$field.'" ';
	if (!$enabled) {
		$html.= 'style="color: gray" ';
	}
	$html.= '>';
	$html.= '<input name="'.$field.'" id="'.$field.'" type="checkbox" ';

	// Initial checked value
	if ($val == true) {
		$html.= 'checked="checked" value="checked" ';
	}

	// Set onclick function
	if (isset($onclick)) {
		$html.= 'onclick="'.$onclick.'()"';
	}

	// Initial enabled state
	if (!$enabled) {
		$html.= 'disabled';
	}
	$html.= '/> '.$label."</label>";
	if (!empty($help)) $html.= '<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<font size="1" color="SlateGray">'.$help.'</font>';
	$html.= "</p></td></tr>\r\n";
	return $html;
}

/**
* Common functions for simple checkboxes 
*
* @param  string  $field   
* @param  boolean $val     
* @param  string  $label   
* @param  string 	$help    
* @param  string  $onclick 
* @return string  Returns html
*/
function ab_makeCheckBoxOnly($field, $val, $label, $help, $onclick = null) {
	$html = '<p><label for="'.$field.'"><input name="'.$field.'" id="'.$field.'" type="checkbox" ';
	if ($val == true) {
		$html.= 'checked="checked" value="checked"';
	}
	if (isset($onclick)) {
		$html.= 'onclick="'.$onclick.'()"';
	}
	$html.= '/> '.$label.'</label></p>';
	return $html;
}


/**
* Common function for radio buttons
* $label is , $val is the index of the selected option
*
* @param  string  $field 
* @param  string  $val    the index of the selected option
* @param  array   $label  an array of options
* @param  string  $help  
* @return string  Returns html
*/
function ab_makeRadioOnly($field, $val, $label, $help) {
	if (is_array($label)) {
		$i = 0;
		foreach($label as $itemlabel) {
			$html.= '<p><label for="'.$field.'"><input name="'.$field.'" id="'.$field.$i.'" type="radio" ';
			if ($val == $i) {
				$html.= 'checked value="'.$i.'"';
			} else {
				$html.= 'value="'.$i.'"';
			}
			$html.= '/> '.$itemlabel.'</label></p>';
			$i++;
		}
		return $html;
	} else {

		// Why use a radio if there's only one option?

	}
}

/**
* Common for making select lists
*
* @param  string  $field      
* @param  array   $values     
* @param  string 	$selected   
* @param  string  $title      
* @param  string  $help       
* @param  boolean $allowblank 
* @param  string  $onchange   
* @param  boolean $enabled    
* @return string  Returns html
*/
function ab_makeSelect($field, $values, $selected, $title, $help = null, $allowblank = true, $onchange = null, $enabled = true) {
	$html = '<tr><td scope="row"><p id="lbl'.$field.'" ';
	if (!$enabled) {
		$html.= 'style="color:gray" ';
	}
	$html.= '>'.$title.':</p></td><td><p><select name="'.$field.'" id="'.$field.'" ';
	if (isset($onchange)) {
		$html.= 'onChange="'.$onchange.'()" ';
	}
	if (!$enabled) {
		$html.= 'disabled ';
	}
	$html.= '>';
	if ($allowblank) echo '<option></option>';
	foreach($values as $value) {
		if (is_array($value)) {
			$label = $value[0];
			$val = $value[1];
		} else {
			$label = $value;
			$val = null;
		}
		$html.= '<option';
		if (strcasecmp($label, $selected) == 0) {
			$html.= ' selected="selected"';
		}
		if (!empty($val)) {
			$html.= ' value = "'.$val.'"';
		}
		$html.= '>'.stripslashes(attribute_escape($label)).'</option>';
	}
	$html.= "</select>";
	if (!empty($help)) {
		$html.= '<br /><font size="1" color="SlateGray">'.$help.'</font>';
	}
	$html.= "</p></td></tr>\r\n";
	return $html;
}

/**
* Common function for text input boxes
*
* @param  string  $field        
* @param  string	$value        
* @param  string  $defaultWidth 
* @param  string  $title        
* @param  string  $help         
* @param  string  $backcolor    
* @param  boolean $enabled      
* @return string  Returns html
*/
function ab_makeTextInput($field, $value, $defaultWidth, $title, $help, $backcolor = '', $enabled = true) {
	$html = '<tr><td scope="row"><p id="lbl'.$field.'">'.$title.': </p></td><td><p><input class="abtext" ';
	if (strlen($backcolor)) $html.= 'style="background-color: '.$backcolor.';" ';
	$html.= 'name="'.$field.'" id="'.$field.'" value="'.stripslashes(attribute_escape($value)).'"';
	if (!empty($defaultWidth)) {
		$html.= ' size="'.$defaultWidth.'"';
	}
	if (!$enabled) {
		$html.= ' disabled';
	}
	$html.= ' />';
	if (!empty($help)) {
		$html.= '<br /><font size="1" color="SlateGray">'.$help.'</font>';
	}
	$html.= "</p></td></tr>\r\n";
	return $html;
}

/**
* Common function for text areas
*
* @param  string  $field   
* @param  string 	$value   
* @param  string  $rows    
* @param  string 	$title   
* @param  string  $caption 
* @param  string  $help    
* @return string  Returns html
*/
function ab_makeWideTextArea($field, $value, $rows, $title, $caption, $help = '') {

	//$html = '<h3>'.$title.'</h3><table>';
	$html = '<table width="90%">';
	$html.= '<tr valign="top"><td><p>'.$caption.'</p></td></tr><tr><td><textarea name="'.$field.'" rows="'.$rows.'" class="abtext" style="width: 100%">'.stripslashes(attribute_escape($value)).'</textarea>';
	if (!empty($help)) {
		$html.= '<br /><font size="1" color="SlateGray">'.$help.'</font>';
	}
	$html.= "</td></tr>\r\n</table><br /><br />";
	return $html;
}

/**
* Common function for half-width text areas
*
* @param  string  $field 
* @param  string 	$value 
* @param  string  $rows  
* @param  string  $title 
* @param  string  $help  
* @return string  Returns html
*/
function ab_makeHalfWidthTextArea($field, $value, $rows, $title, $help) {
	$html.= '<tr valign="top"><td scope="row"><p>'.$title.'</p></td><td><textarea name="'.$field.'" rows="'.$rows.'" class="abtext" style="width: 50%">'.stripslashes(attribute_escape($value)).'</textarea>';
	if (!empty($help)) {
		$html.= '<br /><font size="1" color="SlateGray">'.$help.'</font>';
	}
	$html.= "</td></tr>\r\n";
	return $html;
}

/**
* Common function for value pair tables
*
* @param  array   $headings    
* @param  array   $colOneItems 
* @param  array   $colTwoItems 
* @param  boolean $sar_hack    
* @param  array   $taxonomies  
* @return string  Returs html
*/
function ab_makeValuePairTable($headings, $colOneItems, $colTwoItems, $sar_hack = false, $taxonomies = null) {
	$name = strtolower(str_replace(" ", "", $headings[0]));

	// Search/replace v2.7 hack to avoid a table def update
	if ($sar_hack) {
		$headings[] = 'Search Type';
	}
	$html = '<table id="tbl'.$name.'"><tr><td>&nbsp;</td>';
	foreach($headings as $heading) {
		$html.= '<td><b>'.$heading.'</b></td>';
	}
	$html.= '<td>&nbsp;</td></tr>';
	$i = 0;
	if (is_array($colOneItems)) {
		foreach($colOneItems as $item) {
			if (!empty($colOneItems[$i])) {

				// Search/replace hack, the type is prepended to col 1
				$ret = preg_match("/!!(\d)!!/", $colOneItems[$i], $matches);
				if ($ret && $sar_hack) {
					$colthree = $matches[1];
					$colOne = str_replace($matches[0], '', $colOneItems[$i]);
				} else {
					$colOne = $colOneItems[$i];
					$colthree = 0;
				}

				// Create the html
				$html.= '<tr><td><input type="checkbox" name="chk'.$name.'" /></td>';

				// Special case for custom taxonomies, create combo box
				if (isset($taxonomies)) {
					$html.= '<td><select name="'.$name.'[]" style="width: 150px">';
					$html.= '<option></option>';
					foreach($taxonomies as $taxonomy) {
						$html.= '<option';
						if (strcasecmp($taxonomy, attribute_escape($colOne)) == 0) {
							$html.= ' selected="selected"';
						}
						$html.= '>'.stripslashes(attribute_escape($taxonomy)).'</option>';
					}
					$html.= '</select></td>';
				} else {
					$html.= '<td><input class="abtext" name="'.strtolower(str_replace(" ", "", $headings[0])).'[]" value="'.stripslashes(attribute_escape($colOne)).'" size="50"></td>';
				}
				$html.= '<td><input class="abtext" name="'.strtolower(str_replace(" ", "", $headings[1])).'[]" value="'.stripslashes(attribute_escape($colTwoItems[$i])).'" size="50"></td>';

				// More hackiness
				if ($sar_hack) {
					if ($colthree == 1) {
						$html.= '<td><select name="searchtype[]"><option>Regular Expression</option><option selected="selected">Plain Text</option></select></td>';
					} elseif ($colthree == 0) {
						$html.= '<td><select name="searchtype[]"><option selected="selected">Regular Expression</option><option>Plain Text</option></select></td>';
					}
				}
				$html.= '</tr>';
				$i++;
			}
		}
	}

	// Add a blank line

	// Special case for custom taxonomies, create combo box
	$bhtml.= '<td><input class="abtext" type="checkbox" name="chk'.$name.'" /></td>';
	if (isset($taxonomies)) {
		$bhtml.= '<td><select name="'.strtolower(str_replace(" ", "", $headings[0])).'[]" style="width: 150px">';
		$bhtml.= '<option></option>';
		foreach($taxonomies as $taxonomy) {
			$bhtml.= '<option>'.stripslashes($taxonomy).'</option>';
		}
		$bhtml.= '</select></td>';;
	} else {
		$bhtml.= '<td><input class="abtext" name="'.strtolower(str_replace(" ", "", $headings[0])).'[]" size="50" value=""></td>';
	}
	$bhtml.= '<td><input class="abtext" name="'.strtolower(str_replace(" ", "", $headings[1])).'[]" size="50" value=""></td>';
	if ($sar_hack) {
		$bhtml.= '<td><select name="searchtype[]"><option selected value=""></option><option>Regular Expression</option><option>Plain Text</option></select><br />';
	}
	$html.= '<tr>'.$bhtml.'</tr><tr>'.$bhtml.'</tr><tr>'.$bhtml.'</tr>';
	$html.= "</table>\r\n";

	// Create function for adding a blank line
	echo '<script language="javascript" type="text/javascript">';
	echo 'function add'.$name.'() { ';
	echo 'var table=document.getElementById(\'tbl'.$name.'\');';
	echo 'var rc=table.rows.length;';
	echo 'var row=table.insertRow(rc);';
	echo 'row.innerHTML=\''.$bhtml.'\';';
	echo '}';

	// Create function to remove line
	echo 'function del'.$name.'() { ';
	echo 'var table=document.getElementById(\'tbl'.$name.'\');';
	echo 'var rc=table.rows.length;';
	echo 'for(var i=0; i<rc; i++) {';
	echo 'var row = table.rows[i];';
	echo 'var chk = row.cells[0].childNodes[0];';
	echo 'if(null != chk && true == chk.checked) { ';
	echo 'table.deleteRow(i);';
	echo 'rc--;';
	echo 'i--; } }';
	echo '}</script>';
	$html.= '<input type="button" onClick="del'.$name.'()" value="Delete checked">&nbsp;&nbsp;'; //<input type="button" onClick="add'.$name.'()" value="Add new line">';
	return $html;
}


/**
* Short description for function
*
* @param  array   $sidebars 	An array of titles as keys, functions as values
* @param  string 	$page     
* @param  string  $feed     
* @return void
*/
function ab_doSideBar($sidebars, $page, $feed = '') {
	echo '<div class="submitbox" id="submitlink">';
	foreach(array_keys($sidebars) as $sidebar) {
		add_meta_box(str_replace(' ', '', $sidebar).'div', __($sidebar), $sidebars[$sidebar], $page, 'side', 'core');
	}
	echo '<div id="side-info-column" class="inner-sidebar">';
	$side_meta_boxes = do_meta_boxes($page, 'side', $feed);
	echo '</div></div>';
}

/**
* @return void
*/
function ab_OpenMainSection() {
	echo '<div id="post-body" class="has-sidebar">';
	echo '<div id="post-body-content" class="has-sidebar-content">';
}
?>